/*
Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

#[cfg(feature = "git")]
pub mod operations;
#[cfg(feature = "git")]
pub mod storage;
#[cfg(feature = "git")]
pub mod types;
#[cfg(feature = "git")]
pub mod versioned_store;

#[cfg(feature = "git")]
pub use operations::GitOperations;
#[cfg(feature = "git")]
pub use storage::GitNodeStorage;
#[cfg(feature = "git")]
pub use types::*;
#[cfg(feature = "git")]
pub use versioned_store::VersionedKvStore;
